libretools - Bug #791

Support cross-compiling for other architectures without need extra dependencies
2015-08-20 08:33 AM - Anonymous

Status: fixed % Done: 100%
Priority: feature

Assignee: lukeshu

Category: ARM on x86

Description

Add cross-compiling support to build multiple architectures without need extra dependencies

e support cross-compiling configuration

¢ no need extra dependencies like libretools-mips64el
¢ no need extra steps to build and upload packages

e easy to use libremakepkg/librestage/librerelease

https://labs.parabola.nu/issues/787

Related issues:

Related to dbscripts - Bug #808: Package [dbscripts] similarly to libretools ... fixed 2015-09-22
Blocked by libretools - Porting #787: [librechroot] Support ARM chroots on x8... fixed 2015-08-19
History

#1 - 2015-08-20 06:03 PM - Anonymous
- Related to Porting #787: [librechroot] Support ARM chroots on x86 via QEMU added
#2 - 2015-09-07 10:31 PM - Anonymous
coadde wrote:
Add cross-compiling support to build multiple architectures without need extra dependencies
e support cross-compiling configuration
* no need extra dependencies like libretools-mips64el
® no need extra steps to build and upload packages
L]

easy to use libremakepkg/librestage/librerelease

https://labs.parabola.nu/issues/787

Add pacman flags, example:

e CC and CPP (for native-gcc, crosscompiling-gcc and clang support)
e TARCH (for package-tarball build [*-${TARCH}.pkg.tar.xz])
e CTARGET (for cross-compiling compilation):

example - (crosscompiling_build-mips64el):

FHEHE A A R R
# ARCHITECTURE, COMPILE FLAGS
B
#

CC=mips64el-unknown-linux-gnu-gcc

CPP=mips64el-unknown-linux-gnu-g++

CARCH="x86_64"

TARCH="mips64el"

CHOST="x86_64-unknown-linux—-gnu"

CTARGET="mips64el-unknown-linux—-gnu"

#-— Compiler and Linker Flags

# -march (or -mcpu) builds exclusively for an architecture

# -mtune optimizes for an architecture, but builds for whole processor family
CPPFLAGS="-D_FORTIFY_SOURCE=2"

CFLAGS="-march=mips64el -mtune=generic -02 -pipe -fstack-protector-strong —--param=ssp-buffer-size=4"
CXXFLAGS="-march=mips64el -mtune=generic -02 -pipe -fstack-protector-strong --param=ssp-buffer-size=4"
LDFLAGS="-W1l,-01, -—-sort-common, —-—as—needed, -z, relro, -—hash-style=gnu"

#-- Make Flags: change this for DistCC/SMP systems

MAKEFLAGS="-7j4"

#-— Debugging flags

DEBUG_CFLAGS="-g -fvar-tracking-assignments"

DEBUG_CXXFLAGS="-g —-fvar-tracking-assignments"

example - (native_build-x86_64):

FHA A R R R
# ARCHITECTURE, COMPILE FLAGS

FHEHE A R R
#

CC=gcc

#CC=clang

CPP=g++

#CPP=clang++

CARCH="x86_64"

TARCH="$ {CARCH}"

CHOST="x86_64-unknown-linux—-gnu"

CTARGET="${CHOST}"

#-— Compiler and Linker Flags

# -march (or -mcpu) builds exclusively for an architecture

# -mtune optimizes for an architecture, but builds for whole processor family
CPPFLAGS="-D_FORTIFY_SOURCE=2"

CFLAGS="-march=x86-64 -mtune=generic -02 -pipe -fstack-protector-strong —--param=ssp-buffer-size=4"
CXXFLAGS="-march=x86-64 -mtune=generic -02 -pipe -fstack-protector-strong --param=ssp-buffer-size=4"
LDFLAGS="-W1l,-01, ——sort—-common, ——as—needed, -z, relro, ——hash-style=gnu"

#-- Make Flags: change this for DistCC/SMP systems

MAKEFLAGS="-7j4"

#-— Debugging flags

DEBUG_CFLAGS="-g —-fvar-tracking-assignments"

DEBUG_CXXFLAGS="-g —-fvar-tracking-assignments"

#3 - 2015-09-23 01:49 AM - Anonymous
- Related to Bug #807: [librechroot] Support using proot to call QEMU for foreign architectures added

#4 - 2015-09-23 01:50 AM - Anonymous

- Related to Bug #808: Package [dbscripts] similarly to libretools for easy use in Parabola server added

#5 - 2015-09-23 01:51 AM - Anonymous

- Related to Bug #790: Add support QEMU in chroot on nonnative architecture to build other systems without need to use cross-compiling added

#6 - 2016-04-15 11:14 PM - lukeshu

- Subject changed from Add cross-compiling support to build multiple architectures without need extra dependencies to Support cross-compiling for
other architectures without need extra dependencies

I'm down with most of this, but I'm not sure about dropping having a libretools-cross-${CARCH} (or somesuch) for cross-compiling. For one, it'd be
silly to require gemu be installed on an ARM device to cross-compile for ARM. Similarly, it'd be silly to require that gemu be installed on ARM devices
to cross-compile for x86, since ARM devices are typically under-powered.

#7 - 2016-04-15 11:31 PM - lukeshu
- Related to deleted (Bug #807: [librechroot] Support using proot to call QEMU for foreign architectures)

#8 - 2016-04-15 11:37 PM - lukeshu
- Target version set to Better ARM support

- Category set to ARM on x86

#9 - 2016-04-15 11:49 PM - lukeshu

- Related to deleted (Bug #790: Add support QEMU in chroot on nonnative architecture to build other systems without need to use cross-compiling)

#10 - 2016-04-15 11:50 PM - lukeshu
- Related to deleted (Porting #787: [librechroot] Support ARM chroots on x86 via QEMU)

#11 - 2016-04-15 11:52 PM - lukeshu
- Blocked by Porting #787: [librechroot] Support ARM chroots on x86 via QEMU added

#12 - 2016-05-31 06:22 PM - lukeshu

- Status changed from open to info needed

So, this is added, except for extra dependencies.

Is everyone ok with having the optdepend binftm-gemu-static: To build ARM packages from x86?

#13 - 2016-06-01 07:04 PM - Anonymous

yes

#14 - 2016-06-02 08:40 PM - lukeshu
- % Done changed from 0 to 100

- Status changed from info needed to fixed

Alright then!
